
/* #####################################
   ##                                 ##
   ##  User Modifiable Stuff Starts : ##
   ##                                 ##
   #####################################
*/

#define MU1  1          
#define MU2  500 
/*#define NPROC 4  */     /* Number of Processors for data mapping */
#define TEMPFREEZ  100    /* Factor controlling the tempfreez() function */
#define MAXMSGS 1000;   /* Maximum Number of Messages to Exchange
						 * when syncronizing after peturbations */
/*#define K  0.90 */      /* This factor decides the temperature schedule */
#define THRESH  10      /* Threshold determines when to start saving best
						   so far in the outer loop of sim annealing algo */
#define READ 1
#define WRITE 0
#define N_ACCMAX  1
#define N_ATTMAX 2
#define MVS_CONST 500 /* This is used for as a constant for finding vmvs */
#define ACCEPTABLE_EFFICIENCY 0.05  /* This is for convergence criteria */








/* #####################################
   ##                                 ##
   ##  User Modifiable Stuff ENDS     ##
   ##                                 ##
   #####################################
*/

#define TEMP0     0.056        /* To keep iterations of outter while loop
								* to just 4 for testing purpose
								*/

/* Defined below is the data structure for the graph representing
*  currently the data mapping problem instance. For each graph node 
*  the following information is stored :
*
*     - degree of the node of the undirected graph
*     - pointers to all the nodes which are connected to given node
*     - pointers to proc# of each nabor
*     - Edge weights of each of the edges eminating from the given node
*     - weight assigned to each node
*
*  The "wt" represents the computational load for the node, "egwt" denotes
*  the communication happening between nodes.
*/
 
typedef struct vertx_rec {
    int my_proc;                /* Proc in which vertex lies */
    int   deg;                  /* Vertex degree */
    int  *nabor;                /* Pointer to neighbours of a node */
    int  *proc;                 /* Proc# of the nabor */
    float wt;                   /* Weight of the node */
    float  *egwt;               /* Edge weights */
} vertex_t;



typedef struct sink_tag {

	int dest_proc;
	int local_spin;
	float del_objfn;

} sink_t;




#define NEW(type)  (type *)malloc(sizeof(type))
#define MEM(type,size)  (type *)calloc(size,sizeof(type))

