#include <stdio.h>
#include "/usr/local/express/include/express.h"
#include "psa.h"
#include "decl.h"

extern int NPROC;
#define DEBUG 0

/*-----------------------------------------------------------------------*/
void
glb_synchronize( vertex, sink, max_vertices, cnt_entry_sink, max_moves )
vertex_t *vertex;
sink_t *sink;
int max_vertices;
int cnt_entry_sink;
int max_moves;
{

	int update_row, i, j, ptr, type = 57;
	int *aloc_gsn, *aloc_send_proc, *gsn_buf, *send_proc_buf;

#if DEBUG 
    fasync(stdout);
        printf("Proc:%d, into glb synchro..max Sink %d max vert %d\n",
				mynode(), cnt_entry_sink, max_vertices);
/*      printf("Proc:%d, vertex[max_vertices-1].deg %d\n",
				mynode(), vertex[max_vertices-1].deg); */
    fflush(stdout);
#endif

	aloc_gsn = MEM(int, max_moves);
	aloc_send_proc = MEM(int, max_moves);
	gsn_buf = MEM(int, NPROC*max_moves);
	send_proc_buf = MEM(int, NPROC*max_moves);

	if ( (aloc_gsn == NULL)|| ( aloc_send_proc == NULL) )
        exit(10);                  /* Out Of memory condition */


	/* Now make the arrays aloc_gsn & aloc_send_proc from sinks */

    /* Initializing arrays with -9 */
	for (i=0;i<max_moves;i++) {
		aloc_gsn[i] = -9;
		aloc_send_proc[i] = -9;
	}

    for (i=0;i<cnt_entry_sink;i++) {
        aloc_gsn[i] = sink[i].local_spin;
        aloc_send_proc[i] = sink[i].dest_proc;
    }

 	
	/* Now to do the global concatenation operation on both arrays */

	exconcat(aloc_gsn, max_moves*sizeof(int), gsn_buf,           
            max_moves*sizeof(int), NULLPTR, ALLNODES, NULLPTR, &type);

	exconcat(aloc_send_proc, max_moves*sizeof(int), send_proc_buf,           
            max_moves*sizeof(int), NULLPTR, ALLNODES, NULLPTR, &type);

	/* Global arrays have been prepared */
	
	for (i=0; i< max_moves*NPROC; i++) {

		if (gsn_buf[i] != -9) {   /* Valid item */

			vertex[gsn_buf[i]].my_proc = send_proc_buf[i];

			for (j=0;j< vertex[gsn_buf[i]].deg;j++) {

				/* Go to row for that nabor */
				update_row = vertex[gsn_buf[i]].nabor[j];
				ptr = 0;
				while ( gsn_buf[i] != vertex[update_row].nabor[ptr] ) 
					ptr++;
				vertex[update_row].proc[ptr] = send_proc_buf[i];
			}
		}
	}


} 
/*------------------------------------------------------------------------*/
	
