#include <stdio.h>
#include <stdlib.h>
#include <search.h>
#include <math.h>
#include "/usr/local/express/include/express.h"

extern int NPROC;
#include "psa.h"
#include "decl.h"

#define DEBUG 0

/*----------------------------------------------------------------------*/
int 
local_perturb(vertex, max_vertices, temp, sink, cnt_entry_sink)
vertex_t *vertex;
int max_vertices;
float temp;
sink_t *sink;
int cnt_entry_sink;
{
	int local_index;
	int send_proc, acceptflag;
	float del_objfn;
	float old_del_objfn=0.0;
	int i, SINKSIZE;
    sink_t node;
	

	local_index = rnd(0,max_vertices-1);
    node.local_spin = local_index;
    SINKSIZE = cnt_entry_sink;

	/* Check to see if it is not put in sink earlier. Else reselect */
    while ( ( vertex[local_index].my_proc != mynode() ) || 
	         ((sink_t *)bsearch((char *)(&node), (char *)sink,
             SINKSIZE, sizeof(sink_t), node_compare) != NULL)) {  

				local_index = rnd(0, max_vertices - 1);
				node.local_spin = local_index;
	}


#if DEBUG
    fasync(stdout);
    printf("\n Local Perturb Proc:%d  index:%d\n",mynode(), local_index);
    fflush(stdout);
#endif

    /* Select randomly a proc to send this vertex */

    send_proc = mynode();
    while (send_proc == mynode()) {
        if (mynode() == 0)
            send_proc = rnd((mynode()+1),NPROC-1);
        else
            if (mynode() == NPROC-1)
                send_proc = rnd(0,(mynode()-1));
            else
                send_proc = rnd(0,NPROC-1);
    }


	del_objfn = eval_del_objfn( vertex, max_vertices, local_index,
                                 sink, cnt_entry_sink, send_proc);

	for( i=0; i < cnt_entry_sink; i++)
		old_del_objfn = old_del_objfn + sink[i].del_objfn;

#if DEBUG
    fasync(stdout);
     printf("Proc:%d  Cum_Del_objfn:%f\n",mynode(), old_del_objfn+del_objfn);
    fflush(stdout);
#endif

	acceptflag = accept_or_not(old_del_objfn+del_objfn,temp); 

	if (acceptflag == 1) {  /* The move has been accepted */
		/* Enter the element into the sink */
		sink[cnt_entry_sink].dest_proc=send_proc;
		sink[cnt_entry_sink].local_spin=local_index;
		sink[cnt_entry_sink].del_objfn = del_objfn;
		qsort((char *)sink,cnt_entry_sink+1,sizeof(sink_t),intcompare);
		cnt_entry_sink++;

	}

#if DEBUG
	fasync(stdout);
if (acceptflag == 1) {
	printf("\nProc:%d  Accepted  lsn %d \n",
          mynode(), local_index);
}
else {
	 printf("\nProc:%d  Rejected perurbation for lsn %d\n", mynode(), 
			local_index);
}
	fflush(stdout);
#endif

	return acceptflag;	


}
/*-----------------------------------------------------------------------*/
int
intcompare(i,j)
sink_t *i, *j;
{
	return (i->local_spin - j->local_spin);
}
/*----------------------------------------------------------------------*/
int accept_or_not(dobj,temp)
float dobj;
float temp;
{
	int acceptflag=0;
	float term1, term2;
	double drand48();

	if (dobj <= 0.0) {
		acceptflag = 1;
	}
	else {
		term1 = (float) drand48(); /* Returns no in range [0.0 1.0) */
		term2 = -(dobj / temp);
		if (term2 < -10.0) 
			term2 = 0.0;
		else 
			term2 = (float) exp((double) term2);
#if DEBUG
    fasync(stdout);
    printf("Objfn is +ve Proc:%d,term1:%f,term2:%f\n",mynode(),term1,term2);
    fflush(stdout);
#endif

		if (term1 < term2) 
			acceptflag = 1;
	}
	return acceptflag;
}
/*---------------------------------------------------------------------*/
int rnd(low,high)
int low, high;
{
	double drand48();
	float f;
	int rnd_no;

	f = (float) drand48(); 
	rnd_no = (int)((1-f)*(low-1) + 1 + f*high);
	return rnd_no;
} /*--------------------------------------------------------------------*/
